//ȈI2CCu for GR-SAKURA(RX63N) by I.N.
//iRX63NSCIɔĂȈI2C𗘗pj
//              RXI2CLIB 1.0

//CPU:ICLK=98MHz, PCLK=48MHz, sizeof(int)=4(32bit)

// 2014.12.05 ver.0.1 Jn
// 2014.12.08 ver.0.2 M, iSCI12̂݁j
// 2014.12.09 ver.1.0  (SCI0,1,2,3,5,6,8ǉ)

#ifndef RXI2CLIB_H
#define RXI2CLIB_H

#include <iodefine_gcc63n.h>

#ifdef __cplusplus
extern "C" {
#endif

//`l̍ő(0-3,5-6,8,12)
#define RXI2C_COMNUM 13

// --- obt@ւ̃|C^ ---
volatile unsigned char *RXI2C_buffer[RXI2C_COMNUM];
// RXI2C_ptr[] ͎ɓǂݏf[^ʒuw
volatile int RXI2C_ptr[RXI2C_COMNUM];
// f[^̃TCY
volatile int RXI2C_len[RXI2C_COMNUM];

//I[vtO
char RXI2C_openflag[RXI2C_COMNUM]={0,0,0,0,2,0,0,2,0,2,2,2,0};	//2͎gps`l

//荞݂̏(0:ҋ@ 1:STI)
volatile int rxi2c_status[RXI2C_COMNUM];


//M(RXI0)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI0_RXI0(void)
{
	RXI2C_buffer[0][RXI2C_ptr[0]++]= SCI0.RDR;	//f[^[h
}

//M(TXI0)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI0_TXI0(void)
{
	if(rxi2c_status[0]==12){		//MI
		SCI0.SCR.BIT.RIE= 0;				//݋֎~
		rxi2c_status[0]= 2;
	}
	else if(rxi2c_status[0]>=10){	//M
		//Pڂ̂
		if(rxi2c_status[0]==10){	
			if(!SCI0.SISR.BIT.IICACKR){
				//ACK
				SCI0.SIMR2.BIT.IICACKT= 0;
				SCI0.SCR.BIT.RIE= 1;		//݋
			}else{
				//ACKȂ͏I
				rxi2c_status[0]= 2;
				return;
			}
		}
		//PڂтQڈȍ~
		if(RXI2C_ptr[0]+1 == RXI2C_len[0]){	//ŏIf[^̂Ƃ
			SCI0.SIMR2.BIT.IICACKT= 1;
			rxi2c_status[0]= 12;
		}else{
			rxi2c_status[0]= 11;
		}
		SCI0.TDR= 0xff;		//_~[f[^̃Cg
	}else{
		//M
		if(RXI2C_ptr[0]==RXI2C_len[0]){	
			//Sf[^M͏I
			rxi2c_status[0]= 2;
		}else{
			if(!SCI0.SISR.BIT.IICACKR){
				//ACK͎̃f[^𑗐MCĎTXI҂
				SCI0.TDR= RXI2C_buffer[0][RXI2C_ptr[0]++];	//f[^
			}else{
				//ACKȂ͏I
				rxi2c_status[0]= 2;
			}
		}
	}
}

//MI(TEI0(STI))ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI0_TEI0(void)
{
	SCI0.SIMR3.BIT.IICSTIF= 0;
	while(SCI0.SIMR3.BIT.IICSTIF);

	if(rxi2c_status[0]==0){			//ŏSTI
		SCI0.SIMR3.BYTE= 0x00;		//o̓ZNgFVAf[^NbN	
	}
	else if(rxi2c_status[0]==2){	//ŌSTI
		SCI0.SIMR3.BYTE= 0xF0;		//o̓ZNgFnCCs[_X
	}

	rxi2c_status[0]++;
}


//M(RXI1)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI1_RXI1(void)
{
	RXI2C_buffer[1][RXI2C_ptr[1]++]= SCI1.RDR;	//f[^[h
}

//M(TXI1)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI1_TXI1(void)
{
	if(rxi2c_status[1]==12){		//MI
		SCI1.SCR.BIT.RIE= 0;				//݋֎~
		rxi2c_status[1]= 2;
	}
	else if(rxi2c_status[1]>=10){	//M
		//Pڂ̂
		if(rxi2c_status[1]==10){	
			if(!SCI1.SISR.BIT.IICACKR){
				//ACK
				SCI1.SIMR2.BIT.IICACKT= 0;
				SCI1.SCR.BIT.RIE= 1;		//݋
			}else{
				//ACKȂ͏I
				rxi2c_status[1]= 2;
				return;
			}
		}
		//PڂтQڈȍ~
		if(RXI2C_ptr[1]+1 == RXI2C_len[1]){	//ŏIf[^̂Ƃ
			SCI1.SIMR2.BIT.IICACKT= 1;
			rxi2c_status[1]= 12;
		}else{
			rxi2c_status[1]= 11;
		}
		SCI1.TDR= 0xff;		//_~[f[^̃Cg
	}else{
		//M
		if(RXI2C_ptr[1]==RXI2C_len[1]){	
			//Sf[^M͏I
			rxi2c_status[1]= 2;
		}else{
			if(!SCI1.SISR.BIT.IICACKR){
				//ACK͎̃f[^𑗐MCĎTXI҂
				SCI1.TDR= RXI2C_buffer[1][RXI2C_ptr[1]++];	//f[^
			}else{
				//ACKȂ͏I
				rxi2c_status[1]= 2;
			}
		}
	}
}

//MI(TEI1(STI))ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI1_TEI1(void)
{
	SCI1.SIMR3.BIT.IICSTIF= 0;
	while(SCI1.SIMR3.BIT.IICSTIF);

	if(rxi2c_status[1]==0){			//ŏSTI
		SCI1.SIMR3.BYTE= 0x00;		//o̓ZNgFVAf[^NbN	
	}
	else if(rxi2c_status[1]==2){	//ŌSTI
		SCI1.SIMR3.BYTE= 0xF0;		//o̓ZNgFnCCs[_X
	}

	rxi2c_status[1]++;
}


//M(RXI2)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI2_RXI2(void)
{
	RXI2C_buffer[2][RXI2C_ptr[2]++]= SCI2.RDR;	//f[^[h
}

//M(TXI2)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI2_TXI2(void)
{
	if(rxi2c_status[2]==12){		//MI
		SCI2.SCR.BIT.RIE= 0;				//݋֎~
		rxi2c_status[2]= 2;
	}
	else if(rxi2c_status[2]>=10){	//M
		//Pڂ̂
		if(rxi2c_status[2]==10){	
			if(!SCI2.SISR.BIT.IICACKR){
				//ACK
				SCI2.SIMR2.BIT.IICACKT= 0;
				SCI2.SCR.BIT.RIE= 1;		//݋
			}else{
				//ACKȂ͏I
				rxi2c_status[2]= 2;
				return;
			}
		}
		//PڂтQڈȍ~
		if(RXI2C_ptr[2]+1 == RXI2C_len[2]){	//ŏIf[^̂Ƃ
			SCI2.SIMR2.BIT.IICACKT= 1;
			rxi2c_status[2]= 12;
		}else{
			rxi2c_status[2]= 11;
		}
		SCI2.TDR= 0xff;		//_~[f[^̃Cg
	}else{
		//M
		if(RXI2C_ptr[2]==RXI2C_len[2]){	
			//Sf[^M͏I
			rxi2c_status[2]= 2;
		}else{
			if(!SCI2.SISR.BIT.IICACKR){
				//ACK͎̃f[^𑗐MCĎTXI҂
				SCI2.TDR= RXI2C_buffer[2][RXI2C_ptr[2]++];	//f[^
			}else{
				//ACKȂ͏I
				rxi2c_status[2]= 2;
			}
		}
	}
}

//MI(TEI2(STI))ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI2_TEI2(void)
{
	SCI2.SIMR3.BIT.IICSTIF= 0;
	while(SCI2.SIMR3.BIT.IICSTIF);

	if(rxi2c_status[2]==0){			//ŏSTI
		SCI2.SIMR3.BYTE= 0x00;		//o̓ZNgFVAf[^NbN	
	}
	else if(rxi2c_status[2]==2){	//ŌSTI
		SCI2.SIMR3.BYTE= 0xF0;		//o̓ZNgFnCCs[_X
	}

	rxi2c_status[2]++;
}


//M(RXI3)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI3_RXI3(void)
{
	RXI2C_buffer[3][RXI2C_ptr[3]++]= SCI3.RDR;	//f[^[h
}

//M(TXI3)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI3_TXI3(void)
{
	if(rxi2c_status[3]==12){		//MI
		SCI3.SCR.BIT.RIE= 0;				//݋֎~
		rxi2c_status[3]= 2;
	}
	else if(rxi2c_status[3]>=10){	//M
		//Pڂ̂
		if(rxi2c_status[3]==10){	
			if(!SCI3.SISR.BIT.IICACKR){
				//ACK
				SCI3.SIMR2.BIT.IICACKT= 0;
				SCI3.SCR.BIT.RIE= 1;		//݋
			}else{
				//ACKȂ͏I
				rxi2c_status[3]= 2;
				return;
			}
		}
		//PڂтQڈȍ~
		if(RXI2C_ptr[3]+1 == RXI2C_len[3]){	//ŏIf[^̂Ƃ
			SCI3.SIMR2.BIT.IICACKT= 1;
			rxi2c_status[3]= 12;
		}else{
			rxi2c_status[3]= 11;
		}
		SCI3.TDR= 0xff;		//_~[f[^̃Cg
	}else{
		//M
		if(RXI2C_ptr[3]==RXI2C_len[3]){	
			//Sf[^M͏I
			rxi2c_status[3]= 2;
		}else{
			if(!SCI3.SISR.BIT.IICACKR){
				//ACK͎̃f[^𑗐MCĎTXI҂
				SCI3.TDR= RXI2C_buffer[3][RXI2C_ptr[3]++];	//f[^
			}else{
				//ACKȂ͏I
				rxi2c_status[3]= 2;
			}
		}
	}
}

//MI(TEI3(STI))ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI3_TEI3(void)
{
	SCI3.SIMR3.BIT.IICSTIF= 0;
	while(SCI3.SIMR3.BIT.IICSTIF);

	if(rxi2c_status[3]==0){			//ŏSTI
		SCI3.SIMR3.BYTE= 0x00;		//o̓ZNgFVAf[^NbN	
	}
	else if(rxi2c_status[3]==2){	//ŌSTI
		SCI3.SIMR3.BYTE= 0xF0;		//o̓ZNgFnCCs[_X
	}

	rxi2c_status[3]++;
}


//M(RXI5)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI5_RXI5(void)
{
	RXI2C_buffer[5][RXI2C_ptr[5]++]= SCI5.RDR;	//f[^[h
}

//M(TXI5)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI5_TXI5(void)
{
	if(rxi2c_status[5]==12){		//MI
		SCI5.SCR.BIT.RIE= 0;				//݋֎~
		rxi2c_status[5]= 2;
	}
	else if(rxi2c_status[5]>=10){	//M
		//Pڂ̂
		if(rxi2c_status[5]==10){	
			if(!SCI5.SISR.BIT.IICACKR){
				//ACK
				SCI5.SIMR2.BIT.IICACKT= 0;
				SCI5.SCR.BIT.RIE= 1;		//݋
			}else{
				//ACKȂ͏I
				rxi2c_status[5]= 2;
				return;
			}
		}
		//PڂтQڈȍ~
		if(RXI2C_ptr[5]+1 == RXI2C_len[5]){	//ŏIf[^̂Ƃ
			SCI5.SIMR2.BIT.IICACKT= 1;
			rxi2c_status[5]= 12;
		}else{
			rxi2c_status[5]= 11;
		}
		SCI5.TDR= 0xff;		//_~[f[^̃Cg
	}else{
		//M
		if(RXI2C_ptr[5]==RXI2C_len[5]){	
			//Sf[^M͏I
			rxi2c_status[5]= 2;
		}else{
			if(!SCI5.SISR.BIT.IICACKR){
				//ACK͎̃f[^𑗐MCĎTXI҂
				SCI5.TDR= RXI2C_buffer[5][RXI2C_ptr[5]++];	//f[^
			}else{
				//ACKȂ͏I
				rxi2c_status[5]= 2;
			}
		}
	}
}

//MI(TEI5(STI))ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI5_TEI5(void)
{
	SCI5.SIMR3.BIT.IICSTIF= 0;
	while(SCI5.SIMR3.BIT.IICSTIF);

	if(rxi2c_status[5]==0){			//ŏSTI
		SCI5.SIMR3.BYTE= 0x00;		//o̓ZNgFVAf[^NbN	
	}
	else if(rxi2c_status[5]==2){	//ŌSTI
		SCI5.SIMR3.BYTE= 0xF0;		//o̓ZNgFnCCs[_X
	}

	rxi2c_status[5]++;
}


//M(RXI6)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI6_RXI6(void)
{
	RXI2C_buffer[6][RXI2C_ptr[6]++]= SCI6.RDR;	//f[^[h
}

//M(TXI6)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI6_TXI6(void)
{
	if(rxi2c_status[6]==12){		//MI
		SCI6.SCR.BIT.RIE= 0;				//݋֎~
		rxi2c_status[6]= 2;
	}
	else if(rxi2c_status[6]>=10){	//M
		//Pڂ̂
		if(rxi2c_status[6]==10){	
			if(!SCI6.SISR.BIT.IICACKR){
				//ACK
				SCI6.SIMR2.BIT.IICACKT= 0;
				SCI6.SCR.BIT.RIE= 1;		//݋
			}else{
				//ACKȂ͏I
				rxi2c_status[6]= 2;
				return;
			}
		}
		//PڂтQڈȍ~
		if(RXI2C_ptr[6]+1 == RXI2C_len[6]){	//ŏIf[^̂Ƃ
			SCI6.SIMR2.BIT.IICACKT= 1;
			rxi2c_status[6]= 12;
		}else{
			rxi2c_status[6]= 11;
		}
		SCI6.TDR= 0xff;		//_~[f[^̃Cg
	}else{
		//M
		if(RXI2C_ptr[6]==RXI2C_len[6]){	
			//Sf[^M͏I
			rxi2c_status[6]= 2;
		}else{
			if(!SCI6.SISR.BIT.IICACKR){
				//ACK͎̃f[^𑗐MCĎTXI҂
				SCI6.TDR= RXI2C_buffer[6][RXI2C_ptr[6]++];	//f[^
			}else{
				//ACKȂ͏I
				rxi2c_status[6]= 2;
			}
		}
	}
}

//MI(TEI6(STI))ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI6_TEI6(void)
{
	SCI6.SIMR3.BIT.IICSTIF= 0;
	while(SCI6.SIMR3.BIT.IICSTIF);

	if(rxi2c_status[6]==0){			//ŏSTI
		SCI6.SIMR3.BYTE= 0x00;		//o̓ZNgFVAf[^NbN	
	}
	else if(rxi2c_status[6]==2){	//ŌSTI
		SCI6.SIMR3.BYTE= 0xF0;		//o̓ZNgFnCCs[_X
	}

	rxi2c_status[6]++;
}


//M(RXI8)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI8_RXI8(void)
{
	RXI2C_buffer[8][RXI2C_ptr[8]++]= SCI8.RDR;	//f[^[h
}

//M(TXI8)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI8_TXI8(void)
{
	if(rxi2c_status[8]==12){		//MI
		SCI8.SCR.BIT.RIE= 0;				//݋֎~
		rxi2c_status[8]= 2;
	}
	else if(rxi2c_status[8]>=10){	//M
		//Pڂ̂
		if(rxi2c_status[8]==10){	
			if(!SCI8.SISR.BIT.IICACKR){
				//ACK
				SCI8.SIMR2.BIT.IICACKT= 0;
				SCI8.SCR.BIT.RIE= 1;		//݋
			}else{
				//ACKȂ͏I
				rxi2c_status[8]= 2;
				return;
			}
		}
		//PڂтQڈȍ~
		if(RXI2C_ptr[8]+1 == RXI2C_len[8]){	//ŏIf[^̂Ƃ
			SCI8.SIMR2.BIT.IICACKT= 1;
			rxi2c_status[8]= 12;
		}else{
			rxi2c_status[8]= 11;
		}
		SCI8.TDR= 0xff;		//_~[f[^̃Cg
	}else{
		//M
		if(RXI2C_ptr[8]==RXI2C_len[8]){	
			//Sf[^M͏I
			rxi2c_status[8]= 2;
		}else{
			if(!SCI8.SISR.BIT.IICACKR){
				//ACK͎̃f[^𑗐MCĎTXI҂
				SCI8.TDR= RXI2C_buffer[8][RXI2C_ptr[8]++];	//f[^
			}else{
				//ACKȂ͏I
				rxi2c_status[8]= 2;
			}
		}
	}
}

//MI(TEI8(STI))ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI8_TEI8(void)
{
	SCI8.SIMR3.BIT.IICSTIF= 0;
	while(SCI8.SIMR3.BIT.IICSTIF);

	if(rxi2c_status[8]==0){			//ŏSTI
		SCI8.SIMR3.BYTE= 0x00;		//o̓ZNgFVAf[^NbN	
	}
	else if(rxi2c_status[8]==2){	//ŌSTI
		SCI8.SIMR3.BYTE= 0xF0;		//o̓ZNgFnCCs[_X
	}

	rxi2c_status[8]++;
}


//M(RXI12:250)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI12_RXI12(void)
{
	RXI2C_buffer[12][RXI2C_ptr[12]++]= SCI12.RDR;	//f[^[h
}

//M(TXI12:251)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI12_TXI12(void)
{
	if(rxi2c_status[12]==12){		//MI
		SCI12.SCR.BIT.RIE= 0;				//݋֎~
		rxi2c_status[12]= 2;
	}
	else if(rxi2c_status[12]>=10){	//M
		//Pڂ̂
		if(rxi2c_status[12]==10){	
			if(!SCI12.SISR.BIT.IICACKR){
				//ACK
				SCI12.SIMR2.BIT.IICACKT= 0;
				SCI12.SCR.BIT.RIE= 1;		//݋
			}else{
				//ACKȂ͏I
				rxi2c_status[12]= 2;
				return;
			}
		}
		//PڂтQڈȍ~
		if(RXI2C_ptr[12]+1 == RXI2C_len[12]){	//ŏIf[^̂Ƃ
			SCI12.SIMR2.BIT.IICACKT= 1;
			rxi2c_status[12]= 12;
		}else{
			rxi2c_status[12]= 11;
		}
		SCI12.TDR= 0xff;		//_~[f[^̃Cg
	}else{
		//M
		if(RXI2C_ptr[12]==RXI2C_len[12]){	
			//Sf[^M͏I
			rxi2c_status[12]= 2;
		}else{
			if(!SCI12.SISR.BIT.IICACKR){
				//ACK͎̃f[^𑗐MCĎTXI҂
				SCI12.TDR= RXI2C_buffer[12][RXI2C_ptr[12]++];	//f[^
			}else{
				//ACKȂ͏I
				rxi2c_status[12]= 2;
			}
		}
	}
}

//MI(TEI12 (STI) :252)ŌĂяo
void __attribute__ ((interrupt)) RXI2C_SCI12_TEI12(void)
{
	SCI12.SIMR3.BIT.IICSTIF= 0;
	while(SCI12.SIMR3.BIT.IICSTIF);

	if(rxi2c_status[12]==0){		//ŏSTI
		SCI12.SIMR3.BYTE= 0x00;		//o̓ZNgFVAf[^NbN	
	}
	else if(rxi2c_status[12]==2){	//ŌSTI
		SCI12.SIMR3.BYTE= 0xF0;		//o̓ZNgFnCCs[_X
	}

	rxi2c_status[12]++;
}

//--------------------------------------------------------------------------------
// |[g̃I[v RXI2C_Open()
//--------------------------------------------------------------------------------
// ncom : `lԍ(0-3,5-6,8,12)
// brr  : {[[gw  vZ 48M/(32*(brr+1)) [bps]
//  brrlƃ{[[g(ڑ@킪Ή邩ǂ͕ʂƂ)
//          0 -> 1500000.0 [bps]
//          1 ->  750000.0 [bps]
//          2 ->  500000.0 [bps]
//          3 ->  375000.0 [bps]
//          4 ->  300000.0 [bps]
//         14 ->  100000.0 [bps]
//--------------------------------------------------------------------------------
// gp|[g̃ftHg
// SCI0:  |[gP21(IO0)  =SCL, P20(IO1)  =SDA
// SCI1:  |[gP30(CN6-6)=SCL, P26(CN6-3)=SDA
// SCI2:  |[gP12(IO30) =SCL, P13(IO31) =SDA
// SCI3:  |[gP25(IO5)  =SCL, P23(IO3)  =SDA
// SCI5:  |[gPC2(IO8)  =SCL, PC3(IO9)  =SDA
// SCI6:  |[gP33(IO7)  =SCL, P32(IO6)  =SDA
// SCI8:  |[gPC6(IO11) =SCL, PC7(IO12) =SDA
// SCI12: |[gPE2(IO46) =SCL, PE1(IO45) =SDA
// |[gP33(IO7)=SCL, P32(IO6)=SDAgɂ͎sCN[hOɒ`
//   #define SCI0_SCLSDA_P33P32
// |[gP52(IO26)=SCL, P50(IO24)=SDAgɂ͎sCN[hOɒ`
//   #define SCI2_SCLSDA_P52P50
//--------------------------------------------------------------------------------
int RXI2C_Open(int n, int brr)
{
	if(n<0 || n>=RXI2C_COMNUM) return 2;	//͈̓`FbN
	if(RXI2C_openflag[n]) return RXI2C_openflag[n];	//łɃI[vorgps`l̂Ƃ

	switch(n){
		// ----- SCI0 -----
		case 0:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB31= 0;	//SCI0W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI0.SCR.BYTE= 0x00;			//SCRFTIE,RIE,TE,RE,TEIE0,SCKo͂Ȃ,{[[gWFl[^

			// |[gݒ̕ύX
		#ifdef SCI0_SCLSDA_P33P32
			PORT3.PMR.BIT.B2= 0;			//P32:ėpI/O
			PORT3.PMR.BIT.B3= 0;			//P33:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P32PFS.BIT.PSEL= 0x0b;		//|[gP32:SSDA0
			MPC.P33PFS.BIT.PSEL= 0x0b;		//|[gP33:SSCL0
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORT3.PMR.BIT.B2= 1;			//P32:Ӌ@\ɐݒ
			PORT3.PMR.BIT.B3= 1;			//P33:Ӌ@\ɐݒ
			PORT3.ODR0.BIT.B4= 1;			//P32:m`lI[vhC
			PORT3.ODR0.BIT.B6= 1;			//P33:m`lI[vhC
		#else
			PORT2.PMR.BIT.B0= 0;			//P20:ėpI/O
			PORT2.PMR.BIT.B1= 0;			//P21:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P20PFS.BIT.PSEL= 0x0a;		//|[gP20:SSDA0
			MPC.P21PFS.BIT.PSEL= 0x0a;		//|[gP21:SSCL0
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORT2.PMR.BIT.B0= 1;			//P20:Ӌ@\ɐݒ
			PORT2.PMR.BIT.B1= 1;			//P21:Ӌ@\ɐݒ
			PORT2.ODR0.BIT.B0= 1;			//P20:m`lI[vhC
			PORT2.ODR0.BIT.B2= 1;			//P21:m`lI[vhC
		#endif

			SCI0.SIMR3.BIT.IICSDAS= 3;	//SSDAno̓ZNgFnCCs[_X
			SCI0.SIMR3.BIT.IICSCLS= 3;	//SSCLno̓ZNgFnCCs[_X

			SCI0.SMR.BYTE= 0x00;	//PCLK(48MHz)
			SCI0.SCMR.BYTE= 0xfa;	//VAR~jP[VC^tF[X[h(ȈI2C),SDIR=1(MSBt@[Xg)

			SCI0.BRR= brr;			//{[[g(BRR)w  vZ 48M/(32*(brr+1)) [bps]

			SCI0.SEMR.BYTE= 0x00;		//mCY@\
			SCI0.SNFR.BYTE= 0x00;		//mCYtB^NbNZNg
			SCI0.SIMR1.BYTE= 0x01;		//ȈI2C[hCSSDAo͒xȂ
			SCI0.SIMR2.BIT.IICACKT= 1;	//
			SCI0.SIMR2.BIT.IICCSC= 1;	//
			SCI0.SIMR2.BIT.IICINTM= 1;	//M荞݁CM荞ݎgp
			SCI0.SPMR.BYTE= 0x00;		//

			SCI0.SCR.BYTE |= 0x30;		//TE,RE𓯎ɃZbg

			ICU.IPR[214].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1A].BIT.IEN6= 1;	//荞RXI0                  [xN^214]
			ICU.IER[0x1A].BIT.IEN7= 1;	//荞TXI0                  [xN^215]
			ICU.IER[0x1B].BIT.IEN0= 1;	//荞TEI0 (ȈI2CłSTI) [xN^216]

			ICU.IR[214].BIT.IR= 0;
			ICU.IR[215].BIT.IR= 0;
			ICU.IR[216].BIT.IR= 0;

			SCI0.SCR.BIT.TIE= 1;		//݋
			SCI0.SCR.BIT.TEIE= 1;		//݋
			break;

		// ----- SCI1 -----
		case 1:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB30= 0;	//SCI1W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI1.SCR.BYTE= 0x00;			//SCRFTIE,RIE,TE,RE,TEIE0,SCKo͂Ȃ,{[[gWFl[^

			// |[gݒ̕ύX
			PORT2.PMR.BIT.B6= 0;			//P26:ėpI/O
			PORT3.PMR.BIT.B0= 0;			//P30:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P26PFS.BIT.PSEL= 0x0a;		//|[gP26:SSDA1
			MPC.P30PFS.BIT.PSEL= 0x0a;		//|[gP30:SSCL1
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORT2.PMR.BIT.B6= 1;			//P26:Ӌ@\ɐݒ
			PORT3.PMR.BIT.B0= 1;			//P30:Ӌ@\ɐݒ
			PORT2.ODR1.BIT.B4= 1;			//P26:m`lI[vhC
			PORT3.ODR0.BIT.B0= 1;			//P30:m`lI[vhC

			SCI1.SIMR3.BIT.IICSDAS= 3;	//SSDAno̓ZNgFnCCs[_X
			SCI1.SIMR3.BIT.IICSCLS= 3;	//SSCLno̓ZNgFnCCs[_X

			SCI1.SMR.BYTE= 0x00;	//PCLK(48MHz)
			SCI1.SCMR.BYTE= 0xfa;	//VAR~jP[VC^tF[X[h(ȈI2C),SDIR=1(MSBt@[Xg)

			SCI1.BRR= brr;			//{[[g(BRR)w  vZ 48M/(32*(brr+1)) [bps]

			SCI1.SEMR.BYTE= 0x00;		//mCY@\
			SCI1.SNFR.BYTE= 0x00;		//mCYtB^NbNZNg
			SCI1.SIMR1.BYTE= 0x01;		//ȈI2C[hCSSDAo͒xȂ
			SCI1.SIMR2.BIT.IICACKT= 1;	//
			SCI1.SIMR2.BIT.IICCSC= 1;	//
			SCI1.SIMR2.BIT.IICINTM= 1;	//M荞݁CM荞ݎgp
			SCI1.SPMR.BYTE= 0x00;		//

			SCI1.SCR.BYTE |= 0x30;		//TE,RE𓯎ɃZbg

			ICU.IPR[217].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1B].BIT.IEN1= 1;	//荞RXI1                  [xN^217]
			ICU.IER[0x1B].BIT.IEN2= 1;	//荞TXI1                  [xN^218]
			ICU.IER[0x1B].BIT.IEN3= 1;	//荞TEI1 (ȈI2CłSTI) [xN^219]

			ICU.IR[217].BIT.IR= 0;
			ICU.IR[218].BIT.IR= 0;
			ICU.IR[219].BIT.IR= 0;

			SCI1.SCR.BIT.TIE= 1;		//݋
			SCI1.SCR.BIT.TEIE= 1;		//݋
			break;

		// ----- SCI2 -----
		case 2:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB29= 0;	//SCI2W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI2.SCR.BYTE= 0x00;			//SCRFTIE,RIE,TE,RE,TEIE0,SCKo͂Ȃ,{[[gWFl[^

			// |[gݒ̕ύX
		#ifdef SCI2_SCLSDA_P52P50
			PORT5.PMR.BIT.B0= 0;			//P50:ėpI/O
			PORT5.PMR.BIT.B2= 0;			//P52:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P50PFS.BIT.PSEL= 0x0a;		//|[gP50:SSDA2
			MPC.P52PFS.BIT.PSEL= 0x0a;		//|[gP52:SSCL2
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORT5.PMR.BIT.B0= 1;			//P50:Ӌ@\ɐݒ
			PORT5.PMR.BIT.B2= 1;			//P52:Ӌ@\ɐݒ
			PORT5.ODR0.BIT.B0= 1;			//P50:m`lI[vhC
			PORT5.ODR0.BIT.B4= 1;			//P52:m`lI[vhC
		#else
			PORT1.PMR.BIT.B2= 0;			//P12:ėpI/O
			PORT1.PMR.BIT.B3= 0;			//P13:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P13PFS.BIT.PSEL= 0x0a;		//|[gP13:SSDA2
			MPC.P12PFS.BIT.PSEL= 0x0a;		//|[gP12:SSCL2
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORT1.PMR.BIT.B2= 1;			//P12:Ӌ@\ɐݒ
			PORT1.PMR.BIT.B3= 1;			//P13:Ӌ@\ɐݒ
			PORT1.ODR0.BIT.B4= 1;			//P12:m`lI[vhC
			PORT1.ODR0.BIT.B6= 1;			//P13:m`lI[vhC
		#endif

			SCI2.SIMR3.BIT.IICSDAS= 3;	//SSDAno̓ZNgFnCCs[_X
			SCI2.SIMR3.BIT.IICSCLS= 3;	//SSCLno̓ZNgFnCCs[_X

			SCI2.SMR.BYTE= 0x00;	//PCLK(48MHz)
			SCI2.SCMR.BYTE= 0xfa;	//VAR~jP[VC^tF[X[h(ȈI2C),SDIR=1(MSBt@[Xg)

			SCI2.BRR= brr;			//{[[g(BRR)w  vZ 48M/(32*(brr+1)) [bps]

			SCI2.SEMR.BYTE= 0x00;		//mCY@\
			SCI2.SNFR.BYTE= 0x00;		//mCYtB^NbNZNg
			SCI2.SIMR1.BYTE= 0x01;		//ȈI2C[hCSSDAo͒xȂ
			SCI2.SIMR2.BIT.IICACKT= 1;	//
			SCI2.SIMR2.BIT.IICCSC= 1;	//
			SCI2.SIMR2.BIT.IICINTM= 1;	//M荞݁CM荞ݎgp
			SCI2.SPMR.BYTE= 0x00;		//

			SCI2.SCR.BYTE |= 0x30;		//TE,RE𓯎ɃZbg

			ICU.IPR[220].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1B].BIT.IEN4= 1;	//荞RXI2                  [xN^220]
			ICU.IER[0x1B].BIT.IEN5= 1;	//荞TXI2                  [xN^221]
			ICU.IER[0x1B].BIT.IEN6= 1;	//荞TEI2 (ȈI2CłSTI) [xN^222]

			ICU.IR[220].BIT.IR= 0;
			ICU.IR[221].BIT.IR= 0;
			ICU.IR[222].BIT.IR= 0;

			SCI2.SCR.BIT.TIE= 1;		//݋
			SCI2.SCR.BIT.TEIE= 1;		//݋
			break;

		// ----- SCI3 -----
		case 3:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB28= 0;	//SCI3W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI3.SCR.BYTE= 0x00;			//SCRFTIE,RIE,TE,RE,TEIE0,SCKo͂Ȃ,{[[gWFl[^

			// |[gݒ̕ύX
			PORT2.PMR.BIT.B3= 0;			//P23:ėpI/O
			PORT2.PMR.BIT.B5= 0;			//P25:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P23PFS.BIT.PSEL= 0x0a;		//|[gP23:SSDA3
			MPC.P25PFS.BIT.PSEL= 0x0a;		//|[gP25:SSCL3
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORT2.PMR.BIT.B3= 1;			//P23:Ӌ@\ɐݒ
			PORT2.PMR.BIT.B5= 1;			//P25:Ӌ@\ɐݒ
			PORT2.ODR0.BIT.B6= 1;			//P23:m`lI[vhC
			PORT2.ODR1.BIT.B2= 1;			//P25:m`lI[vhC

			SCI3.SIMR3.BIT.IICSDAS= 3;	//SSDAno̓ZNgFnCCs[_X
			SCI3.SIMR3.BIT.IICSCLS= 3;	//SSCLno̓ZNgFnCCs[_X

			SCI3.SMR.BYTE= 0x00;	//PCLK(48MHz)
			SCI3.SCMR.BYTE= 0xfa;	//VAR~jP[VC^tF[X[h(ȈI2C),SDIR=1(MSBt@[Xg)

			SCI3.BRR= brr;			//{[[g(BRR)w  vZ 48M/(32*(brr+1)) [bps]

			SCI3.SEMR.BYTE= 0x00;		//mCY@\
			SCI3.SNFR.BYTE= 0x00;		//mCYtB^NbNZNg
			SCI3.SIMR1.BYTE= 0x01;		//ȈI2C[hCSSDAo͒xȂ
			SCI3.SIMR2.BIT.IICACKT= 1;	//
			SCI3.SIMR2.BIT.IICCSC= 1;	//
			SCI3.SIMR2.BIT.IICINTM= 1;	//M荞݁CM荞ݎgp
			SCI3.SPMR.BYTE= 0x00;		//

			SCI3.SCR.BYTE |= 0x30;		//TE,RE𓯎ɃZbg

			ICU.IPR[223].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1B].BIT.IEN7= 1;	//荞RXI3                  [xN^223]
			ICU.IER[0x1C].BIT.IEN0= 1;	//荞TXI3                  [xN^224]
			ICU.IER[0x1C].BIT.IEN1= 1;	//荞TEI3 (ȈI2CłSTI) [xN^225]

			ICU.IR[223].BIT.IR= 0;
			ICU.IR[224].BIT.IR= 0;
			ICU.IR[225].BIT.IR= 0;

			SCI3.SCR.BIT.TIE= 1;		//݋
			SCI3.SCR.BIT.TEIE= 1;		//݋
			break;

		// ----- SCI5 -----
		case 5:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB26= 0;	//SCI5W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI5.SCR.BYTE= 0x00;			//SCRFTIE,RIE,TE,RE,TEIE0,SCKo͂Ȃ,{[[gWFl[^

			// |[gݒ̕ύX
			PORTC.PMR.BIT.B2= 0;			//PC2:ėpI/O
			PORTC.PMR.BIT.B3= 0;			//PC3:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.PC3PFS.BIT.PSEL= 0x0a;		//|[gPC3:SSDA5
			MPC.PC2PFS.BIT.PSEL= 0x0a;		//|[gPC2:SSCL5
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORTC.PMR.BIT.B2= 1;			//PC2:Ӌ@\ɐݒ
			PORTC.PMR.BIT.B3= 1;			//PC3:Ӌ@\ɐݒ
			PORTC.ODR0.BIT.B4= 1;			//PC2:m`lI[vhC
			PORTC.ODR0.BIT.B6= 1;			//PC3:m`lI[vhC

			SCI5.SIMR3.BIT.IICSDAS= 3;	//SSDAno̓ZNgFnCCs[_X
			SCI5.SIMR3.BIT.IICSCLS= 3;	//SSCLno̓ZNgFnCCs[_X

			SCI5.SMR.BYTE= 0x00;	//PCLK(48MHz)
			SCI5.SCMR.BYTE= 0xfa;	//VAR~jP[VC^tF[X[h(ȈI2C),SDIR=1(MSBt@[Xg)

			SCI5.BRR= brr;			//{[[g(BRR)w  vZ 48M/(32*(brr+1)) [bps]

			SCI5.SEMR.BYTE= 0x00;		//mCY@\
			SCI5.SNFR.BYTE= 0x00;		//mCYtB^NbNZNg
			SCI5.SIMR1.BYTE= 0x01;		//ȈI2C[hCSSDAo͒xȂ
			SCI5.SIMR2.BIT.IICACKT= 1;	//
			SCI5.SIMR2.BIT.IICCSC= 1;	//
			SCI5.SIMR2.BIT.IICINTM= 1;	//M荞݁CM荞ݎgp
			SCI5.SPMR.BYTE= 0x00;		//

			SCI5.SCR.BYTE |= 0x30;		//TE,RE𓯎ɃZbg

			ICU.IPR[229].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1C].BIT.IEN5= 1;	//荞RXI5                  [xN^229]
			ICU.IER[0x1C].BIT.IEN6= 1;	//荞TXI5                  [xN^230]
			ICU.IER[0x1C].BIT.IEN7= 1;	//荞TEI5 (ȈI2CłSTI) [xN^231]

			ICU.IR[229].BIT.IR= 0;
			ICU.IR[230].BIT.IR= 0;
			ICU.IR[231].BIT.IR= 0;

			SCI5.SCR.BIT.TIE= 1;		//݋
			SCI5.SCR.BIT.TEIE= 1;		//݋
			break;

		// ----- SCI6 -----
		case 6:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB25= 0;	//SCI6W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI6.SCR.BYTE= 0x00;			//SCRFTIE,RIE,TE,RE,TEIE0,SCKo͂Ȃ,{[[gWFl[^

			// |[gݒ̕ύX
			PORT3.PMR.BIT.B2= 0;			//P32:ėpI/O
			PORT3.PMR.BIT.B3= 0;			//P33:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.P32PFS.BIT.PSEL= 0x0a;		//|[gP32:SSDA6
			MPC.P33PFS.BIT.PSEL= 0x0a;		//|[gP33:SSCL6
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORT3.PMR.BIT.B2= 1;			//P32:Ӌ@\ɐݒ
			PORT3.PMR.BIT.B3= 1;			//P33:Ӌ@\ɐݒ
			PORT3.ODR0.BIT.B4= 1;			//P32:m`lI[vhC
			PORT3.ODR0.BIT.B6= 1;			//P33:m`lI[vhC

			SCI6.SIMR3.BIT.IICSDAS= 3;	//SSDAno̓ZNgFnCCs[_X
			SCI6.SIMR3.BIT.IICSCLS= 3;	//SSCLno̓ZNgFnCCs[_X

			SCI6.SMR.BYTE= 0x00;	//PCLK(48MHz)
			SCI6.SCMR.BYTE= 0xfa;	//VAR~jP[VC^tF[X[h(ȈI2C),SDIR=1(MSBt@[Xg)

			SCI6.BRR= brr;			//{[[g(BRR)w  vZ 48M/(32*(brr+1)) [bps]

			SCI6.SEMR.BYTE= 0x00;		//mCY@\
			SCI6.SNFR.BYTE= 0x00;		//mCYtB^NbNZNg
			SCI6.SIMR1.BYTE= 0x01;		//ȈI2C[hCSSDAo͒xȂ
			SCI6.SIMR2.BIT.IICACKT= 1;	//
			SCI6.SIMR2.BIT.IICCSC= 1;	//
			SCI6.SIMR2.BIT.IICINTM= 1;	//M荞݁CM荞ݎgp
			SCI6.SPMR.BYTE= 0x00;		//

			SCI6.SCR.BYTE |= 0x30;		//TE,RE𓯎ɃZbg

			ICU.IPR[232].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1D].BIT.IEN0= 1;	//荞RXI6                  [xN^232]
			ICU.IER[0x1D].BIT.IEN1= 1;	//荞TXI6                  [xN^233]
			ICU.IER[0x1D].BIT.IEN2= 1;	//荞TEI6 (ȈI2CłSTI) [xN^234]

			ICU.IR[232].BIT.IR= 0;
			ICU.IR[233].BIT.IR= 0;
			ICU.IR[234].BIT.IR= 0;

			SCI6.SCR.BIT.TIE= 1;		//݋
			SCI6.SCR.BIT.TEIE= 1;		//݋
			break;

		// ----- SCI8 -----
		case 8:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRC.BIT.MSTPC27= 0;	//SCI8W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI8.SCR.BYTE= 0x00;			//SCRFTIE,RIE,TE,RE,TEIE0,SCKo͂Ȃ,{[[gWFl[^

			// |[gݒ̕ύX
			PORTC.PMR.BIT.B6= 0;			//PC6:ėpI/O
			PORTC.PMR.BIT.B7= 0;			//PC7:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.PC7PFS.BIT.PSEL= 0x0a;		//|[gPC7:SSDA8
			MPC.PC6PFS.BIT.PSEL= 0x0a;		//|[gPC6:SSCL8
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORTC.PMR.BIT.B6= 1;			//PC6:Ӌ@\ɐݒ
			PORTC.PMR.BIT.B7= 1;			//PC7:Ӌ@\ɐݒ
			PORTC.ODR1.BIT.B4= 1;			//PC6:m`lI[vhC
			PORTC.ODR1.BIT.B6= 1;			//PC7:m`lI[vhC

			SCI8.SIMR3.BIT.IICSDAS= 3;	//SSDAno̓ZNgFnCCs[_X
			SCI8.SIMR3.BIT.IICSCLS= 3;	//SSCLno̓ZNgFnCCs[_X

			SCI8.SMR.BYTE= 0x00;	//PCLK(48MHz)
			SCI8.SCMR.BYTE= 0xfa;	//VAR~jP[VC^tF[X[h(ȈI2C),SDIR=1(MSBt@[Xg)

			SCI8.BRR= brr;			//{[[g(BRR)w  vZ 48M/(32*(brr+1)) [bps]

			SCI8.SEMR.BYTE= 0x00;		//mCY@\
			SCI8.SNFR.BYTE= 0x00;		//mCYtB^NbNZNg
			SCI8.SIMR1.BYTE= 0x01;		//ȈI2C[hCSSDAo͒xȂ
			SCI8.SIMR2.BIT.IICACKT= 1;	//
			SCI8.SIMR2.BIT.IICCSC= 1;	//
			SCI8.SIMR2.BIT.IICINTM= 1;	//M荞݁CM荞ݎgp
			SCI8.SPMR.BYTE= 0x00;		//

			SCI8.SCR.BYTE |= 0x30;		//TE,RE𓯎ɃZbg

			ICU.IPR[238].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1D].BIT.IEN6= 1;	//荞RXI8                  [xN^238]
			ICU.IER[0x1D].BIT.IEN7= 1;	//荞TXI8                  [xN^239]
			ICU.IER[0x1E].BIT.IEN0= 1;	//荞TEI8 (ȈI2CłSTI) [xN^240]

			ICU.IR[238].BIT.IR= 0;
			ICU.IR[239].BIT.IR= 0;
			ICU.IR[240].BIT.IR= 0;

			SCI8.SCR.BIT.TIE= 1;		//݋
			SCI8.SCR.BIT.TEIE= 1;		//݋
			break;

		// ----- SCI12 -----
		case 12:
			SYSTEM.PRCR.WORD= 0xA502;		//veNgWX^ij
			SYSTEM.MSTPCRB.BIT.MSTPB4= 0;	//SCI12W[~̉
			SYSTEM.PRCR.WORD= 0xA500;		//veNgWX^iیj

			SCI12.SCR.BYTE= 0x00;			//SCRFTIE,RIE,TE,RE,TEIE0,SCKo͂Ȃ,{[[gWFl[^

			// |[gݒ̕ύX
			PORTE.PMR.BIT.B1= 0;			//PE1:ėpI/O
			PORTE.PMR.BIT.B2= 0;			//PE2:ėpI/O
			MPC.PWPR.BIT.B0WI= 0;
			MPC.PWPR.BIT.PFSWE= 1;
			MPC.PE1PFS.BIT.PSEL= 0x0c;		//|[gPE1:SSCL12
			MPC.PE2PFS.BIT.PSEL= 0x0c;		//|[gPE2:SSDA12
			MPC.PWPR.BIT.PFSWE= 0;
			MPC.PWPR.BIT.B0WI= 1;
			PORTE.PMR.BIT.B1= 1;			//PE1:Ӌ@\ɐݒ
			PORTE.PMR.BIT.B2= 1;			//PE2:Ӌ@\ɐݒ
			PORTE.ODR0.BIT.B2= 1;			//PE1:m`lI[vhC
			PORTE.ODR0.BIT.B3= 0;			//PE1:\rbg
			PORTE.ODR0.BIT.B4= 1;			//PE2:m`lI[vhC

			SCI12.SIMR3.BIT.IICSDAS= 3;	//SSDAno̓ZNgFnCCs[_X
			SCI12.SIMR3.BIT.IICSCLS= 3;	//SSCLno̓ZNgFnCCs[_X

			SCI12.SMR.BYTE= 0x00;	//PCLK(48MHz)
			SCI12.SCMR.BYTE= 0xfa;	//VAR~jP[VC^tF[X[h(ȈI2C),SDIR=1(MSBt@[Xg)

			SCI12.BRR= brr;			//{[[g(BRR)w  vZ 48M/(32*(brr+1)) [bps]

			SCI12.SEMR.BYTE= 0x00;		//mCY@\
			SCI12.SNFR.BYTE= 0x00;		//mCYtB^NbNZNg
			SCI12.SIMR1.BYTE= 0x01;		//ȈI2C[hCSSDAo͒xȂ
			SCI12.SIMR2.BIT.IICACKT= 1;	//
			SCI12.SIMR2.BIT.IICCSC= 1;	//
			SCI12.SIMR2.BIT.IICINTM= 1;	//M荞݁CM荞ݎgp
			SCI12.SPMR.BYTE= 0x00;		//

			SCI12.SCR.BYTE |= 0x30;		//TE,RE𓯎ɃZbg

			ICU.IPR[250].BIT.IPR= 5;	//荞ݗD惌x(15:ō)
			ICU.IER[0x1F].BIT.IEN2= 1;	//荞RXI12                  [xN^250]
			ICU.IER[0x1F].BIT.IEN3= 1;	//荞TXI12                  [xN^251]
			ICU.IER[0x1F].BIT.IEN4= 1;	//荞TEI12 (ȈI2CłSTI) [xN^252]

			ICU.IR[250].BIT.IR= 0;
			ICU.IR[251].BIT.IR= 0;
			ICU.IR[252].BIT.IR= 0;

			SCI12.SCR.BIT.TIE= 1;		//݋
			SCI12.SCR.BIT.TEIE= 1;		//݋
			break;
	}

	//I[vtÕZbg
	RXI2C_openflag[n]= 1;
	return 0;
}

//Jn̐(n:`l)
void rxi2c_i2c_start(int n)
{
	switch(n){
		case  0:  SCI0.SIMR3.BYTE= 0x51; break;
		case  1:  SCI1.SIMR3.BYTE= 0x51; break;
		case  2:  SCI2.SIMR3.BYTE= 0x51; break;
		case  3:  SCI3.SIMR3.BYTE= 0x51; break;
		case  5:  SCI5.SIMR3.BYTE= 0x51; break;
		case  6:  SCI6.SIMR3.BYTE= 0x51; break;
		case  8:  SCI8.SIMR3.BYTE= 0x51; break;
		case 12: SCI12.SIMR3.BYTE= 0x51; break;
	}
}

//~̐(n:`l)
void rxi2c_i2c_stop(int n)
{
	switch(n){
		case  0:  SCI0.SIMR3.BYTE= 0x54; break;
		case  1:  SCI1.SIMR3.BYTE= 0x54; break;
		case  2:  SCI2.SIMR3.BYTE= 0x54; break;
		case  3:  SCI3.SIMR3.BYTE= 0x54; break;
		case  5:  SCI5.SIMR3.BYTE= 0x54; break;
		case  6:  SCI6.SIMR3.BYTE= 0x54; break;
		case  8:  SCI8.SIMR3.BYTE= 0x54; break;
		case 12: SCI12.SIMR3.BYTE= 0x54; break;
	}
}

//X[uAhX̃Zbg
// adr:X[uAhXiփrbgVtgO̒l:7bitLj
// bit: Write=0/Read=1
void rxi2c_i2c_slave_adr(int n, int adr, int bit)
{
	switch(n){
		case  0:  SCI0.TDR= adr<<1 | bit; break;
		case  1:  SCI1.TDR= adr<<1 | bit; break;
		case  2:  SCI2.TDR= adr<<1 | bit; break;
		case  3:  SCI3.TDR= adr<<1 | bit; break;
		case  5:  SCI5.TDR= adr<<1 | bit; break;
		case  6:  SCI6.TDR= adr<<1 | bit; break;
		case  8:  SCI8.TDR= adr<<1 | bit; break;
		case 12: SCI12.TDR= adr<<1 | bit; break;
	}
}

// f[^̑MiMɖ߂j
// Mobt@tɂȂ΁Cȍ~̃f[^͔j
// adr:X[uAhXiփrbgVtgO̒l:7bitLj
// ߂lFMoCg
int RXI2C_Send(int n, int adr, void *buf, int size)
{
	if(n<0 || n>=RXI2C_COMNUM) return 0;
	if(RXI2C_openflag[n]!=1) return 0;
	if(size<=0) return 0;
	
	RXI2C_buffer[n]= (unsigned char *)buf;
	RXI2C_len[n]= size;
	RXI2C_ptr[n]= 0;

	rxi2c_status[n]= 0;
	
	//Jn̐
	rxi2c_i2c_start(n);

	//STI荞݂҂
	while(rxi2c_status[n] != 1);

	//X[uAhX̃Zbg bit: Write=0/Read=1
	rxi2c_i2c_slave_adr(n,adr,0);

	//TXI荞݊SI҂
	while(rxi2c_status[n] != 2);

	//~̐
	rxi2c_i2c_stop(n);

	//STI荞݂҂
	while(rxi2c_status[n] != 3);

	rxi2c_status[n]= 0;

	return RXI2C_ptr[n];
}

// f[^̎M (ǂݏof[^buf֊i[)
// adr:X[uAhXiփrbgVtgO̒l:7bitLj
// ߂lFMoCg
int RXI2C_Recv(int n, int adr, void *buf, int size)
{
	if(n<0 || n>=RXI2C_COMNUM) return 0;
	if(RXI2C_openflag[n]!=1) return 0;
	if(size<=0) return 0;

	RXI2C_buffer[n]= (unsigned char *)buf;
	RXI2C_len[n]= size;
	RXI2C_ptr[n]= 0;

	rxi2c_status[n]= 0;

	//Jn̐
	rxi2c_i2c_start(n);

	//STI荞݂҂
	while(rxi2c_status[n] != 1);

	rxi2c_status[n]= 10;

	//X[uAhX̃Zbg bit: Write=0/Read=1
	rxi2c_i2c_slave_adr(n,adr,1);

	//TXI,RXI荞݊SI҂
	while(rxi2c_status[n] != 2);

	//~̐
	rxi2c_i2c_stop(n);

	//STI荞݂҂
	while(rxi2c_status[n] != 3);

	rxi2c_status[n]= 0;

	return RXI2C_ptr[n];
}

// f[^Mi1oCgj ߂lFMoCg
int RXI2C_Send1(int n, int adr, unsigned char d1)
{
	unsigned char b[1];
	b[0]= d1;
	return RXI2C_Send(n,adr,b,1);
}

// f[^Mi2oCgj ߂lFMoCg
int RXI2C_Send2(int n, int adr, unsigned char d1, unsigned char d2)
{
	unsigned char b[2];
	b[0]= d1;
	b[1]= d2;
	return RXI2C_Send(n,adr,b,2);
}

// f[^Mi3oCgj ߂lFMoCg
int RXI2C_Send3(int n, int adr, unsigned char d1, unsigned char d2, unsigned char d3)
{
	unsigned char b[3];
	b[0]= d1;
	b[1]= d2;
	b[2]= d3;
	return RXI2C_Send(n,adr,b,3);
}

// f[^Mi1oCgj ߂lFMoCg
int RXI2C_Recv1(int n, int adr, unsigned char *pd1)
{
	unsigned char b[1];
	int r;
	r= RXI2C_Recv(n,adr,b,1);
	*pd1= b[0];
	return r;
}

// f[^Mi2oCgj ߂lFMoCg
int RXI2C_Recv2(int n, int adr, unsigned char *pd1, unsigned char *pd2)
{
	unsigned char b[2];
	int r;
	r= RXI2C_Recv(n,adr,b,2);
	*pd1= b[0];
	*pd2= b[1];
	return r;
}

// f[^Mi3oCgj ߂lFMoCg
int RXI2C_Recv3(int n, int adr, unsigned char *pd1, unsigned char *pd2, unsigned char *pd3)
{
	unsigned char b[3];
	int r;
	r= RXI2C_Recv(n,adr,b,3);
	*pd1= b[0];
	*pd2= b[1];
	*pd3= b[2];
	return r;
}


#ifdef __cplusplus
}
#endif

#endif
